/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dspurify
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Purify a dataset
	Description: Purify a dataset.


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>
#include <dal_utilities.h>

#include "MemFitsReaderWriterX.h"

#include "dspurify.h"

void dspurify()
{
	PROC
	const string	srcName( stringParameter( "set" ) );
	string	destName( stringParameter( "outset" ) );

	MemFitsReaderWriterX*	readerWriter = new MemFitsReaderWriterX;

	if( destName.empty() )
	{
		destName = srcName;
	}
	else
	{
		dataSetServer -> copy( srcName, destName );
	}// if

	DataSet*		set = dataSetServer -> open(
						destName,
						Dal::Modify,
						DataSetServer::High,
						readerWriter );

	dataSetServer -> close( set );

	ENDPROC
}
