/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dssetlabel
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Set the label of an array, table, column or attribute
	Description: Set the label of an array, table, column or attribute


*/

#include <Tracer.h>
//#include <errstr.h>
#include <param.h>

#include <Dal.h>

// #include <dal_utilities.h>

#include <CompoundName.h>



#include "dssetlabel.h"

void dssetlabel()
{
	PROC
	const string	name( stringParameter( "object" ) );
	const string	label( stringParameter( "label" ) );

	DataSet*		set( dataSetServer -> open( name, Dal::Read, DataSetServer::Low ) );
	const CompoundName	cn( name, CompoundName::Any, set );

	switch( cn.state() )
	{
		case CompoundName::ArrayName :
			set -> array( name ) -> relabel( label );
			break;

		case CompoundName::ColumnName :
			set -> table( name ) -> column( name ) -> relabel( label );
			break;
		case CompoundName::DataSetAttributeName :
			set -> attribute( name ) -> relabel( label );
			break;
		case CompoundName::BlockAttributeName :
			set -> block( name ) -> attribute( name ) -> relabel( label );
			break;
		case CompoundName::ColumnAttributeName :
			set -> table( name ) -> column( name ) -> attribute( name ) -> relabel( label );
			break;
		default :
			errstr << "Object type " << name << " not supported" << Sas::error( "unsupportedObjectType" );

		dataSetServer -> close( set );
	} // switch
	ENDPROC
}

