/*
	Automatically generated source file template for a task.
	(c) European Space Agency


	Title: dstranstype
	Package: daltools
	Author: Mark Thomas
	Affiliation: CARA/ESA
	Email: mthomas@astro.estec.esa.nl
	Purpose: Convert the datatype of a list of objects
	Description: Convert the datatype of a list of objects


*/

#include <Tracer.h>
#include <param.h>
#include <Dal.h>
#include <dal_utilities.h>
#include <CompoundName.h>


#include "dstranstype.h"

void dstranstype()
{
	PROC
	const vector<string>	objects( stringListParameter( "objects" ) );
	Dal::DataType		type( toDalDataType( stringParameter( "type" )));
	
	for( unsigned int i = 0; i < objects.size(); ++i )
	{
		const string		name( objects[ i ] );
		DataSet*		set( dataSetServer -> open( name, Dal::Modify ) );
		const CompoundName	cn( name, CompoundName::Any, set );

		switch( cn.state() )
		{
			case CompoundName::ArrayName :
			{
				Array* array = set -> array( name );
				convertType( array, type );
				break;
			}
			case CompoundName::ColumnName :
			{
				Table* table = set -> table( name );
				Column* column = table -> column( name );
				convertType( column, type );
				break;
			}
			default :
				errstr << "Object type " << name << " not supported" << Sas::error( "unsupportedObjectType" );
		} // switch
		dataSetServer -> close( set );
	} // if
	ENDPROC
}
